function varargout = GolayCorrelator_GUI(varargin)
%GOLAYCORRELATOR_GUI M-file for GolayCorrelator_GUI.fig
%      GOLAYCORRELATOR_GUI, by itself, creates a new GOLAYCORRELATOR_GUI or raises the existing
%      singleton*.
%
%      H = GOLAYCORRELATOR_GUI returns the handle to a new GOLAYCORRELATOR_GUI or the handle to
%      the existing singleton*.
%
%      GOLAYCORRELATOR_GUI('Property','Value',...) creates a new GOLAYCORRELATOR_GUI using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to GolayCorrelator_GUI_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      GOLAYCORRELATOR_GUI('CALLBACK') and GOLAYCORRELATOR_GUI('CALLBACK',hObject,...) call the
%      local function named CALLBACK in GOLAYCORRELATOR_GUI.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GolayCorrelator_GUI

% Last Modified by GUIDE v2.5 13-Apr-2014 01:01:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GolayCorrelator_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GolayCorrelator_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before GolayCorrelator_GUI is made visible.
function GolayCorrelator_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for GolayCorrelator_GUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GolayCorrelator_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);
%Cofigure Generation mode
startup;
set(handles.Generation,'value',1);
set(handles.Correlation,'value',0);

set(handles.CodeLen,'string',{'128','64','32'});
set(handles.CodeLen,'value',1); %CodeLen = 128

set(handles.StaggeredMode,'value',0);
set(handles.StaggeredMode,'enable','off');

set(handles.TotalSamplesTitle,'enable','off');
set(handles.TotalSamples,'enable','off');
set(handles.TotalSamples,'string','0');

set(handles.ChunkSizeTitle,'enable','off');
set(handles.ChunkSize,'enable','off');
set(handles.ChunkSize,'string','0');

set(handles.GaPlot,'visible','off');
set(handles.GbPlot,'visible','off');
set(handles.GaSeqArray,'visible','on');
set(handles.GaSeqArray,'string','');
set(handles.GbSeqArray,'visible','on');
set(handles.GbSeqArray,'string','');

set(handles.InputFileNameTitle,'enable','off');
set(handles.InputFileName,'string','');
set(handles.InputFileName,'enable','off');
set(handles.InputFileName,'max',1);

set(handles.RemovehalfPIrotation,'value',0);
set(handles.RemovehalfPIrotation,'enable','off');

set(handles.OutputFilePath,'string','');
set(handles.OutputFilePath,'max',1);

set(handles.Writetofile,'value',0);

cla(handles.GaPlot);
cla(handles.GbPlot);
return

% --- Outputs from this function are returned to the command line.
function varargout = GolayCorrelator_GUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
return


function InputFileName_Callback(hObject, eventdata, handles)
% hObject    handle to InputFileName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of InputFileName as text
%        str2double(get(hObject,'String')) returns contents of InputFileName as a double
if(~strcmp(get(hObject,'string'),''))
    FilePath = get(hObject,'string');
    [Samples] = dlmread(['' FilePath ''],' ');
    set(handles.TotalSamples,'string',num2str(length(Samples)-1));
    set(handles.ChunkSize,'string',num2str(floor((length(Samples)-1)/10)));
    handles.Samples = Samples;
    guidata(hObject,handles);
end
return

% --- Executes during object creation, after setting all properties.
function InputFileName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to InputFileName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return


function OutputFilePath_Callback(hObject, eventdata, handles)
% hObject    handle to OutputFilePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of OutputFilePath as text
%        str2double(get(hObject,'String')) returns contents of OutputFilePath as a double
return

% --- Executes during object creation, after setting all properties.
function OutputFilePath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to OutputFilePath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return

% --- Executes on button press in Writetofile.
function Writetofile_Callback(hObject, eventdata, handles)
% hObject    handle to Writetofile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Writetofile
if(get(hObject,'value'))
    if(strcmp(get(handles.OutputFilePath,'string'),''))
        P = pwd;
        set(handles.OutputFilePath,'string',P);
    end
end

return


function GbSeqArray_Callback(hObject, eventdata, handles)
% hObject    handle to GbSeqArray (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of GbSeqArray as text
%        str2double(get(hObject,'String')) returns contents of GbSeqArray as a double
return

% --- Executes during object creation, after setting all properties.
function GbSeqArray_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GbSeqArray (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return


function GaSeqArray_Callback(hObject, eventdata, handles)
% hObject    handle to GaSeqArray (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of GaSeqArray as text
%        str2double(get(hObject,'String')) returns contents of GaSeqArray as a double
return

% --- Executes during object creation, after setting all properties.
function GaSeqArray_CreateFcn(hObject, eventdata, handles)
% hObject    handle to GaSeqArray (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return


function TotalSamples_Callback(hObject, eventdata, handles)
% hObject    handle to TotalSamples (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TotalSamples as text
%        str2double(get(hObject,'String')) returns contents of TotalSamples as a double
return

% --- Executes during object creation, after setting all properties.
function TotalSamples_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TotalSamples (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return


function ChunkSize_Callback(hObject, eventdata, handles)
% hObject    handle to ChunkSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ChunkSize as text
%        str2double(get(hObject,'String')) returns contents of ChunkSize as a double
return

% --- Executes during object creation, after setting all properties.
function ChunkSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ChunkSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return

% --- Executes on selection change in CodeLen.
function CodeLen_Callback(hObject, eventdata, handles)
% hObject    handle to CodeLen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns CodeLen contents as cell array
%        contents{get(hObject,'Value')} returns selected item from CodeLen
return

% --- Executes during object creation, after setting all properties.
function CodeLen_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CodeLen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
return

% --- Executes on button press in Preset.
function Preset_Callback(hObject, eventdata, handles)
% hObject    handle to Preset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%Cofigure Generation mode
set(handles.Generation,'value',1);
set(handles.Correlation,'value',0);

set(handles.CodeLen,'string',{'128','64','32'});
set(handles.CodeLen,'value',1); %CodeLen = 128

set(handles.StaggeredMode,'enable','off');
set(handles.StaggeredMode,'value',0);

set(handles.TotalSamplesTitle,'enable','off');
set(handles.TotalSamples,'enable','off');
set(handles.TotalSamples,'string','0');

set(handles.ChunkSizeTitle,'enable','off');
set(handles.ChunkSize,'enable','off');
set(handles.ChunkSize,'string','0');

set(handles.GaPlot,'visible','off');
set(handles.GbPlot,'visible','off');
set(handles.GaSeqArray,'visible','on');
set(handles.GaSeqArray,'string','');
set(handles.GbSeqArray,'visible','on');
set(handles.GbSeqArray,'string','');

set(handles.InputFileNameTitle,'enable','off');
set(handles.InputFileName,'string','');
set(handles.InputFileName,'enable','off');
set(handles.RemovehalfPIrotation,'value',0);
set(handles.RemovehalfPIrotation,'enable','off');

set(handles.OutputFilePath,'string','');
set(handles.OutputFilePath,'max',2);

set(handles.Writetofile,'value',0);

cla(handles.GaPlot);
cla(handles.GbPlot);
return

% --- Executes on button press in Run.
function Run_Callback(hObject, eventdata, handles)
% hObject    handle to Run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if(get(hObject,'value'))
    mode = get(handles.Generation,'value')*0 + get(handles.Correlation,'value')*1;
    CL = [128 64 32];
    CodeLen = CL(get(handles.CodeLen,'value'));
    set(handles.Ga,'String',['Ga' num2str(CodeLen)]);
    set(handles.Gb,'String',['Gb' num2str(CodeLen)]);
    cla(handles.GaPlot);
    cla(handles.GbPlot);
    pause(1);
    if(~mode)
        Samples = [1 zeros(1,CodeLen-1)];
        [GaSeq GbSeq] = GolayCorrelator(Samples, CodeLen);
        GaOut = GaSeq(CodeLen:-1:1)*CodeLen;
        GbOut = GbSeq(CodeLen:-1:1)*CodeLen;
        GaS = []; GbS = [];
        for k=1:CodeLen            
            if(GaOut(k) > 0)
                GaS = [GaS '+' num2str(abs(GaOut(k))) ' '];
            else
                GaS = [GaS '-' num2str(abs(GaOut(k))) ' '];
            end
            if(GbOut(k) > 0)
                GbS = [GbS '+' num2str(abs(GbOut(k))) ' '];
            else
                GbS = [GbS '-' num2str(abs(GbOut(k))) ' '];
            end
        end
        set(handles.GaSeqArray,'string',GaS);
        set(handles.GbSeqArray,'string',GbS);
        if(get(handles.Writetofile,'value'))
            DP = get(handles.OutputFilePath,'string');
            fa = [DP '\GaSeq' num2str(CodeLen) '.txt'];
            fb = [DP '\GbSeq' num2str(CodeLen) '.txt'];
            dlmwrite(fa,GaOut,'delimiter',' ','precision','%1.0f');
            dlmwrite(fb,GbOut,'delimiter',' ','precision','%1.0f');
        end
    else
        StagMode = get(handles.StaggeredMode,'value');
        if(StagMode)
            TotalSamples = str2num(get(handles.TotalSamples,'string'));
            ChunkSize    = str2num(get(handles.ChunkSize,'string'));
        end
        Samples = handles.Samples;
        RemovePIbyrotation = get(handles.RemovehalfPIrotation,'value');

        if(StagMode)
            Len     = TotalSamples;
            iterations = floor(Len/ChunkSize);
            lastiteration = TotalSamples - floor(Len/ChunkSize)*ChunkSize;
            State = [];Ga = []; Gb = [];indxOffset = 0;indx = [];
            Gap = []; Gbp = [];
            for k=0:iterations-1
                if(RemovePIbyrotation)                    
                    InpSeq = Samples(k*ChunkSize+1 : (k+1)*ChunkSize) .* exp(-j*(indxOffset+[0:ChunkSize-1])*pi/2);
                else
                    InpSeq = Samples(k*ChunkSize+1 : (k+1)*ChunkSize);
                end
                
                [GaSeq GbSeq StateOut] = GolayCorrelator(InpSeq,CodeLen,'FirstIteration',(k==0),'State',State);
                State = StateOut;
                Ga = [Ga GaSeq];Gb = [Gb GbSeq];
                Gap = [Gap ; GaSeq];Gbp = [Gbp ;GbSeq];
                indx = [indx ; indxOffset+[1:ChunkSize]];
                indxOffset = ChunkSize + indxOffset;
            end

            %Last Iteration
            if(lastiteration)
                if(RemovePIbyrotation)
                    InpSeq = Samples(iterations*ChunkSize+1:iterations*ChunkSize+lastiteration) .* exp(-j*(indxOffset+[0:lastiteration-1])*pi/2);
                else
                    InpSeq = Samples(iterations*ChunkSize+1:iterations*ChunkSize+lastiteration);
                end
                [GaSeq GbSeq StateOut] = GolayCorrelator(InpSeq,CodeLen,'FirstIteration',0,'State',State);
                State = StateOut;
                Ga = [Ga GaSeq];Gb = [Gb GbSeq];
                
                indx = [indx ; indxOffset+[1:ChunkSize]];
                Gap = [Gap ; [GaSeq zeros(1,(ChunkSize-lastiteration))]];
                Gbp = [Gbp ; [GbSeq zeros(1,(ChunkSize-lastiteration))]];
            end
            maxA = max(abs(Ga));
            maxB = max(abs(Gb)); maxV = max(maxA,maxB);
            plot(handles.GaPlot,indx.',real(Gap).');axis(handles.GaPlot,[0 TotalSamples -maxV maxV]);
            plot(handles.GbPlot,indx.',real(Gbp).');axis(handles.GbPlot,[0 TotalSamples -maxV maxV]);
            hold(handles.GaPlot,'on');
            hold(handles.GbPlot,'on');
        else          
            if(RemovePIbyrotation)
                TotalSamples = str2num(get(handles.TotalSamples,'string'));
                Samples = Samples(1:TotalSamples) .* exp(-j*[0:TotalSamples-1]*pi/2);
            end
            [Ga Gb] = GolayCorrelator(Samples, CodeLen);
            maxA = max(abs(Ga));
            maxB = max(abs(Gb)); maxV = max(maxA,maxB);
            plot(handles.GaPlot,real(Ga));axis(handles.GaPlot,[0 length(Ga) -maxV maxV]);
            plot(handles.GbPlot,real(Gb));axis(handles.GaPlot,[0 length(Ga) -maxV maxV]);
        end

        
        if(get(handles.Writetofile,'value'))
            DP = get(handles.OutputFilePath,'string');
            fa = [DP '\GaCor' num2str(CodeLen) '.txt'];
            fb = [DP '\GbCor' num2str(CodeLen) '.txt'];
            dlmwrite(fa,Ga,'delimiter',' ','precision','%1.3f');
            dlmwrite(fb,Gb,'delimiter',' ','precision','%1.3f');
        end
    end
end

return

% --- Executes on button press in StaggeredMode.
function StaggeredMode_Callback(hObject, eventdata, handles)
% hObject    handle to StaggeredMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of StaggeredMode
    if(get(hObject,'value'))
        set(handles.ChunkSizeTitle,'enable','on');
        set(handles.ChunkSize,'enable','on');
    else
        set(handles.ChunkSizeTitle,'enable','off');
        set(handles.ChunkSize,'enable','off');
    end
return


function TestMode_SelectionChangeFcn(hObject,eventdata,handles)
% hObject    handle to DMG (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

return


% --- Executes during object creation, after setting all properties.
function TestMode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TestMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
return


% --- Executes on button press in Generation.
function Generation_Callback(hObject, eventdata, handles)
% hObject    handle to Generation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Generation
if(get(hObject,'value'))
    set(handles.StaggeredMode,'enable','off');

    set(handles.TotalSamplesTitle,'enable','off');
    set(handles.TotalSamples,'enable','off');

    set(handles.ChunkSizeTitle,'enable','off');
    set(handles.ChunkSize,'enable','off');

    set(handles.GaPlot,'visible','off');
    set(handles.GbPlot,'visible','off');
    set(handles.GaSeqArray,'visible','on');
    set(handles.GbSeqArray,'visible','on');

    set(handles.InputFileNameTitle,'enable','off');
    set(handles.InputFileName,'enable','off');
    set(handles.RemovehalfPIrotation,'enable','off');    
end
return

% --- Executes on button press in Correlation.
function Correlation_Callback(hObject, eventdata, handles)
% hObject    handle to Correlation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Correlation
if(get(hObject,'value'))
    set(handles.StaggeredMode,'Enable','on');
    if(get(handles.StaggeredMode,'value'))
        set(handles.ChunkSizeTitle,'enable','on');
        set(handles.ChunkSize,'enable','on');
    else
        set(handles.ChunkSizeTitle,'enable','off');
        set(handles.ChunkSize,'enable','off');
    end
    
    set(handles.TotalSamplesTitle,'enable','on');
    set(handles.TotalSamples,'enable','on');
    
    set(handles.GaPlot,'visible','on');
    set(handles.GbPlot,'visible','on');
    set(handles.GaSeqArray,'visible','off');
    set(handles.GbSeqArray,'visible','off');

    set(handles.InputFileNameTitle,'enable','on');
    set(handles.InputFileName,'enable','on');
    set(handles.RemovehalfPIrotation,'enable','on');
    set(handles.RemovehalfPIrotation,'value',1);

end
return


% --- Executes on button press in RemovehalfPIrotation.
function RemovehalfPIrotation_Callback(hObject, eventdata, handles)
% hObject    handle to RemovehalfPIrotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of RemovehalfPIrotation


